<?php
namespace Bushelpowered\Api\Grain\Contracts\V1\Model;
        
class PricingLineRaw implements \Bushelpowered\Api\Common\Event\RawRecord, \Bushelpowered\Api\Common\HasSourceTimestamps
{
    public string $tenantId;
    public string $datasourceId;
    public string $integrationId;
    public string $sourceId;
    public ?string $sourceLocationId = null;
    public ?string $locationIntegrationId = null;
    public string $sourceContractId;
    public string $contractIntegrationId;
    public ?float $sourceBasisPrice = null;
    public ?float $sourceCashPrice = null;
    public ?string $sourceCurrency = null;
    /** @var null|string $sourceDeliveryPeriodStart of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $sourceDeliveryPeriodStart = null;
    /** @var null|string $sourceDeliveryPeriodEnd of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $sourceDeliveryPeriodEnd = null;
    public ?string $sourceDeliveryStatus = null;
    public ?string $sourceDisplayId = null;
    public ?string $sourceFuturesMonth = null;
    public ?float $sourceFuturesPrice = null;
    /** @var null|string $sourcePricedAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $sourcePricedAt = null;
    public ?string $sourcePricingStatus = null;
    public ?float $sourceQuantityDelivered = null;
    public ?float $sourceQuantityPriced = null;
    public ?string $sourceQuantityUom = null;
    public ?float $sourceEstimatedAdditionalAdjustment = null;
    public ?float $sourceEstimatedFutures = null;
    public ?float $sourceAdjustment = null;
    public ?int $sourceSequenceNumber = null;
    public ?string $sourceSignatureStatus = null;
    public ?string $sourceComments = null;
    public ?\Bushelpowered\Api\Grain\Contracts\V1\Model\PricingHistorySyncWrapper $pricingHistories = null;
    public ?string $sourceAccountId = null;
    /** @var string $sourceUpdatedAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $sourceUpdatedAt;
    /** @var string $sourceCreatedAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $sourceCreatedAt;
    /** @var null|string $sourceDeletedAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $sourceDeletedAt = null;

    /**
     * @param  null|string  $sourceDeliveryPeriodStart of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  null|string  $sourceDeliveryPeriodEnd of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  null|string  $sourcePricedAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  string  $sourceUpdatedAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  string  $sourceCreatedAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  null|string  $sourceDeletedAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function __construct(string $tenantId, string $datasourceId, string $integrationId, string $sourceId, ?string $sourceLocationId, ?string $locationIntegrationId, string $sourceContractId, string $contractIntegrationId, ?float $sourceBasisPrice, ?float $sourceCashPrice, ?string $sourceCurrency, ?string $sourceDeliveryPeriodStart, ?string $sourceDeliveryPeriodEnd, ?string $sourceDeliveryStatus, ?string $sourceDisplayId, ?string $sourceFuturesMonth, ?float $sourceFuturesPrice, ?string $sourcePricedAt, ?string $sourcePricingStatus, ?float $sourceQuantityDelivered, ?float $sourceQuantityPriced, ?string $sourceQuantityUom, ?float $sourceEstimatedAdditionalAdjustment, ?float $sourceEstimatedFutures, ?float $sourceAdjustment, ?int $sourceSequenceNumber, ?string $sourceSignatureStatus, ?string $sourceComments, ?\Bushelpowered\Api\Grain\Contracts\V1\Model\PricingHistorySyncWrapper $pricingHistories, ?string $sourceAccountId, string $sourceUpdatedAt, string $sourceCreatedAt, ?string $sourceDeletedAt)
    {
        $this->tenantId = $tenantId;
        $this->datasourceId = $datasourceId;
        $this->integrationId = $integrationId;
        $this->sourceId = $sourceId;
        $this->sourceLocationId = $sourceLocationId;
        $this->locationIntegrationId = $locationIntegrationId;
        $this->sourceContractId = $sourceContractId;
        $this->contractIntegrationId = $contractIntegrationId;
        $this->sourceBasisPrice = $sourceBasisPrice;
        $this->sourceCashPrice = $sourceCashPrice;
        $this->sourceCurrency = $sourceCurrency;
        $this->sourceDeliveryPeriodStart = $sourceDeliveryPeriodStart;
        $this->sourceDeliveryPeriodEnd = $sourceDeliveryPeriodEnd;
        $this->sourceDeliveryStatus = $sourceDeliveryStatus;
        $this->sourceDisplayId = $sourceDisplayId;
        $this->sourceFuturesMonth = $sourceFuturesMonth;
        $this->sourceFuturesPrice = $sourceFuturesPrice;
        $this->sourcePricedAt = $sourcePricedAt;
        $this->sourcePricingStatus = $sourcePricingStatus;
        $this->sourceQuantityDelivered = $sourceQuantityDelivered;
        $this->sourceQuantityPriced = $sourceQuantityPriced;
        $this->sourceQuantityUom = $sourceQuantityUom;
        $this->sourceEstimatedAdditionalAdjustment = $sourceEstimatedAdditionalAdjustment;
        $this->sourceEstimatedFutures = $sourceEstimatedFutures;
        $this->sourceAdjustment = $sourceAdjustment;
        $this->sourceSequenceNumber = $sourceSequenceNumber;
        $this->sourceSignatureStatus = $sourceSignatureStatus;
        $this->sourceComments = $sourceComments;
        $this->pricingHistories = $pricingHistories;
        $this->sourceAccountId = $sourceAccountId;
        $this->sourceUpdatedAt = $sourceUpdatedAt;
        $this->sourceCreatedAt = $sourceCreatedAt;
        $this->sourceDeletedAt = $sourceDeletedAt;
    }
    
    public function getTenantId(): string
    {
        return $this->tenantId;
    }
    public function getDatasourceId(): string
    {
        return $this->datasourceId;
    }
    public function getIntegrationId(): string
    {
        return $this->integrationId;
    }
    public function getSourceId(): string
    {
        return $this->sourceId;
    }
    public function getSourceLocationId(): ?string
    {
        return $this->sourceLocationId;
    }
    public function getSourceAccountId(): ?string
    {
        return $this->sourceAccountId;
    }
    /**
     * @return string of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getSourceUpdatedAt(): string
    {
        return $this->sourceUpdatedAt;
    }
    /**
     * @return string of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getSourceCreatedAt(): string
    {
        return $this->sourceCreatedAt;
    }
    /**
     * @return null|string of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getSourceDeletedAt(): ?string
    {
        return $this->sourceDeletedAt;
    }
}