<?php
namespace Bushelpowered\Api\Trade\Offers\V1\Events;
        
class OrderEvent implements \Bushelpowered\Api\Common\Event\Event
{
    public string $datasourceId;
    public \Bushelpowered\Api\Trade\Offers\V1\OrderStatus $status;
    public \Bushelpowered\Api\Trade\Offers\V1\Model\OrderStandard $data;
    public string $idempotencyKey;
    /** @var string $eventCreationTime of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $eventCreationTime;
    public ?string $tenantId = null;

    /**
     * @param  string  $eventCreationTime of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function __construct(string $datasourceId, \Bushelpowered\Api\Trade\Offers\V1\OrderStatus $status, \Bushelpowered\Api\Trade\Offers\V1\Model\OrderStandard $data, string $idempotencyKey, string $eventCreationTime, ?string $tenantId)
    {
        $this->datasourceId = $datasourceId;
        $this->status = $status;
        $this->data = $data;
        $this->idempotencyKey = $idempotencyKey;
        $this->eventCreationTime = $eventCreationTime;
        $this->tenantId = $tenantId;
    }
    
    public function getIdempotencyKey(): string
    {
        return $this->idempotencyKey;
    }
    /**
     * @return string of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getEventCreationTime(): string
    {
        return $this->eventCreationTime;
    }
    public function getTenantId(): ?string
    {
        return $this->tenantId;
    }
}