<?php
namespace Bushelpowered\Api\Trade\Offers\V1\Model;
        
class OrderStandard 
{
    public string $id;
    public string $companySlug;
    public string $contractId;
    public int $quantity;
    public float $price;
    public float $basisPrice;
    public float $futuresPrice;
    public ?string $comments = null;
    public string $bushelAccount;
    public string $erpAccount;
    public string $erpLocation;
    public string $erpCommodity;
    /** @var string $orderCreatedAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $orderCreatedAt;
    /** @var string $expiresAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $expiresAt;
    public bool $forceFill;
    public bool $careOrder;
    public string $contractSymbol;
    public int $pricingType;
    public string $unitOfMeasure;
    public string $commodityCode;
    public string $commodityName;
    public string $locationName;
    public string $exchangeAbbreviation;
    public string $futuresSymbol;
    /** @var string $deliveryStart of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $deliveryStart;
    /** @var string $deliveryEnd of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $deliveryEnd;
    public string $chainOrderId;

    /**
     * @param  string  $orderCreatedAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  string  $expiresAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  string  $deliveryStart of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  string  $deliveryEnd of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function __construct(string $id, string $companySlug, string $contractId, int $quantity, float $price, float $basisPrice, float $futuresPrice, ?string $comments, string $bushelAccount, string $erpAccount, string $erpLocation, string $erpCommodity, string $orderCreatedAt, string $expiresAt, bool $forceFill, bool $careOrder, string $contractSymbol, int $pricingType, string $unitOfMeasure, string $commodityCode, string $commodityName, string $locationName, string $exchangeAbbreviation, string $futuresSymbol, string $deliveryStart, string $deliveryEnd, string $chainOrderId)
    {
        $this->id = $id;
        $this->companySlug = $companySlug;
        $this->contractId = $contractId;
        $this->quantity = $quantity;
        $this->price = $price;
        $this->basisPrice = $basisPrice;
        $this->futuresPrice = $futuresPrice;
        $this->comments = $comments;
        $this->bushelAccount = $bushelAccount;
        $this->erpAccount = $erpAccount;
        $this->erpLocation = $erpLocation;
        $this->erpCommodity = $erpCommodity;
        $this->orderCreatedAt = $orderCreatedAt;
        $this->expiresAt = $expiresAt;
        $this->forceFill = $forceFill;
        $this->careOrder = $careOrder;
        $this->contractSymbol = $contractSymbol;
        $this->pricingType = $pricingType;
        $this->unitOfMeasure = $unitOfMeasure;
        $this->commodityCode = $commodityCode;
        $this->commodityName = $commodityName;
        $this->locationName = $locationName;
        $this->exchangeAbbreviation = $exchangeAbbreviation;
        $this->futuresSymbol = $futuresSymbol;
        $this->deliveryStart = $deliveryStart;
        $this->deliveryEnd = $deliveryEnd;
        $this->chainOrderId = $chainOrderId;
    }
    

}